# Fabien CAPRI pour GIE SERAIL - 2019
# v 1.1 : février 2019
# amélioration du rendu : verbe + listing
# v 1.2 : février 2019
# prise en compte des accentset des fichiers 2D
# Script de verification et d'analyse d'un fichier CAD NEIGe
# Distribué sous Licence GPL - version 3

import arcpy
import os
import datetime
import io
# ------------------------------ CREATION TABLEAU
a01 = str(u'\u2502'.encode('utf-8'))   #  0xB3 -> BOX DRAWINGS LIGHT VERTICAL
a02 = str(u'\u2524'.encode('utf-8'))   #  0xB4 -> BOX DRAWINGS LIGHT VERTICAL AND LEFT
a03 = str(u'\u2561'.encode('utf-8'))   #  0xB5 -> BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE
a04 = str(u'\u2562'.encode('utf-8'))   #  0xB6 -> BOX DRAWINGS VERTICAL DOUBLE AND LEFT SINGLE
a05 = str(u'\u2556'.encode('utf-8'))   #  0xB7 -> BOX DRAWINGS DOWN DOUBLE AND LEFT SINGLE
a06 = str(u'\u2555'.encode('utf-8'))   #  0xB8 -> BOX DRAWINGS DOWN SINGLE AND LEFT DOUBLE
a07 = str(u'\u2563'.encode('utf-8'))   #  0xB9 -> BOX DRAWINGS DOUBLE VERTICAL AND LEFT
a08 = str(u'\u2551'.encode('utf-8'))   #  0xBA -> BOX DRAWINGS DOUBLE VERTICAL
a09 = str(u'\u2557'.encode('utf-8'))   #  0xBB -> BOX DRAWINGS DOUBLE DOWN AND LEFT
a10 = str(u'\u255d'.encode('utf-8'))   #  0xBC -> BOX DRAWINGS DOUBLE UP AND LEFT
a11 = str(u'\u255c'.encode('utf-8'))   #  0xBD -> BOX DRAWINGS UP DOUBLE AND LEFT SINGLE
a12 = str(u'\u255b'.encode('utf-8'))   #  0xBE -> BOX DRAWINGS UP SINGLE AND LEFT DOUBLE
a13 = str(u'\u2510'.encode('utf-8'))   #  0xBF -> BOX DRAWINGS LIGHT DOWN AND LEFT
a14 = str(u'\u2514'.encode('utf-8'))   #  0xC0 -> BOX DRAWINGS LIGHT UP AND RIGHT
a15 = str(u'\u2534'.encode('utf-8'))   #  0xC1 -> BOX DRAWINGS LIGHT UP AND HORIZONTAL
a16 = str(u'\u252c'.encode('utf-8'))   #  0xC2 -> BOX DRAWINGS LIGHT DOWN AND HORIZONTAL
a17 = str(u'\u251c'.encode('utf-8'))   #  0xC3 -> BOX DRAWINGS LIGHT VERTICAL AND RIGHT
a18 = str(u'\u2500'.encode('utf-8'))   #  0xC4 -> BOX DRAWINGS LIGHT HORIZONTAL
a19 = str(u'\u253c'.encode('utf-8'))   #  0xC5 -> BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL
a20 = str(u'\u255e'.encode('utf-8'))   #  0xC6 -> BOX DRAWINGS VERTICAL SINGLE AND RIGHT DOUBLE
a21 = str(u'\u255f'.encode('utf-8'))   #  0xC7 -> BOX DRAWINGS VERTICAL DOUBLE AND RIGHT SINGLE
a22 = str(u'\u255a'.encode('utf-8'))   #  0xC8 -> BOX DRAWINGS DOUBLE UP AND RIGHT
a23 = str(u'\u2554'.encode('utf-8'))   #  0xC9 -> BOX DRAWINGS DOUBLE DOWN AND RIGHT
a24 = str(u'\u2569'.encode('utf-8'))   #  0xCA -> BOX DRAWINGS DOUBLE UP AND HORIZONTAL
a25 = str(u'\u2566'.encode('utf-8'))   #  0xCB -> BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL
a26 = str(u'\u2560'.encode('utf-8'))   #  0xCC -> BOX DRAWINGS DOUBLE VERTICAL AND RIGHT
a27 = str(u'\u2550'.encode('utf-8'))   #  0xCD -> BOX DRAWINGS DOUBLE HORIZONTAL
a28 = str(u'\u256c'.encode('utf-8'))   #  0xCE -> BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL
a29 = str(u'\u2567'.encode('utf-8'))   #  0xCF -> BOX DRAWINGS UP SINGLE AND HORIZONTAL DOUBLE
a30 = str(u'\u2568'.encode('utf-8'))   #  0xD0 -> BOX DRAWINGS UP DOUBLE AND HORIZONTAL SINGLE
a31 = str(u'\u2564'.encode('utf-8'))   #  0xD1 -> BOX DRAWINGS DOWN SINGLE AND HORIZONTAL DOUBLE
a32 = str(u'\u2565'.encode('utf-8'))   #  0xD2 -> BOX DRAWINGS DOWN DOUBLE AND HORIZONTAL SINGLE
a33 = str(u'\u2559'.encode('utf-8'))   #  0xD3 -> BOX DRAWINGS UP DOUBLE AND RIGHT SINGLE
a34 = str(u'\u2558'.encode('utf-8'))   #  0xD4 -> BOX DRAWINGS UP SINGLE AND RIGHT DOUBLE
a35 = str(u'\u2552'.encode('utf-8'))   #  0xD5 -> BOX DRAWINGS DOWN SINGLE AND RIGHT DOUBLE
a36 = str(u'\u2553'.encode('utf-8'))   #  0xD6 -> BOX DRAWINGS DOWN DOUBLE AND RIGHT SINGLE
a37 = str(u'\u256b'.encode('utf-8'))   #  0xD7 -> BOX DRAWINGS VERTICAL DOUBLE AND HORIZONTAL SINGLE
a38 = str(u'\u256a'.encode('utf-8'))   #  0xD8 -> BOX DRAWINGS VERTICAL SINGLE AND HORIZONTAL DOUBLE
a39 = str(u'\u2518'.encode('utf-8'))   #  0xD9 -> BOX DRAWINGS LIGHT UP AND LEFT
a40 = str(u'\u250c'.encode('utf-8'))   #  0xDA -> BOX DRAWINGS LIGHT DOWN AND RIGHT

def LIGNE_DEP():
    LIGNE = a23
    for i in range(20): LIGNE = LIGNE + a27
    LIGNE = LIGNE + a31
    for j in range(2):
        for i in range(12): LIGNE = LIGNE + a27
        LIGNE = LIGNE + a31
    for j in range(7):
        for i in range(10): LIGNE = LIGNE + a27
        LIGNE = LIGNE + a31
    for i in range(10): LIGNE = LIGNE + a27
    LIGNE = LIGNE + a09
    return LIGNE

def LIGNE_FIN():
    LIGNE = a22
    for i in range(20): LIGNE = LIGNE + a27
    LIGNE = LIGNE + a29
    for j in range(2):
        for i in range(12): LIGNE = LIGNE + a27
        LIGNE = LIGNE + a29
    for j in range(7):
        for i in range(10): LIGNE = LIGNE + a27
        LIGNE = LIGNE + a29
    for i in range(10): LIGNE = LIGNE + a27
    LIGNE = LIGNE + a10
    return LIGNE

def PREMIERE_LIGNE():
    LIGNE = a08
    for i in range(20): LIGNE = LIGNE + a27
    LIGNE = LIGNE + a31
    for j in range(2):
        for i in range(12): LIGNE = LIGNE + a27
        LIGNE = LIGNE + a31
    for j in range(7):
        for i in range(10): LIGNE = LIGNE + a27
        LIGNE = LIGNE + a31
    for i in range(10): LIGNE = LIGNE + a27
    LIGNE = LIGNE + a09
    return LIGNE

def LIGNE_VIERGE():
    LIGNE = a08 +  " NOM                " +  a01  +  " TYPE       " +  a01  +  " SELECTION  " +  a01 + " POINTS   " +  a01 + " BLOC     " +  a01 + " BLOC=NOM " +  a01 + " POLYLIGN " +  a01 + " POLYGONE " +  a01 + " Z = 0    " +  a01 + " TT Z = 0 " +  a01 + " PRB GEOM " +  a08
    return LIGNE

def INTERLIGNE():
    LIGNE = a08
    for i in range(20): LIGNE = LIGNE +  a27
    LIGNE = LIGNE + a38
    for j in range(2):
        for i in range(12): LIGNE = LIGNE + a27
        LIGNE = LIGNE + a38
    for j in range(7):
        for i in range(10): LIGNE = LIGNE + a27
        LIGNE = LIGNE + a38
    for i in range(10): LIGNE = LIGNE + a27
    LIGNE = LIGNE + a08
    return LIGNE

def INTERLIGNE_SIMPLE():
    LIGNE = a08
    for i in range(20): LIGNE = LIGNE +  a18
    LIGNE = LIGNE + a38
    for j in range(2):
        for i in range(12): LIGNE = LIGNE + a18
        LIGNE = LIGNE + a38
    for j in range(7):
        for i in range(10): LIGNE = LIGNE + a18
        LIGNE = LIGNE + a38
    for i in range(10): LIGNE = LIGNE + a18
    LIGNE = LIGNE + a08
    return LIGNE

def LIGNE_RMPL(LN):
    LIGNE = a08
    #01 - NOM LAYER
    VALEUR = LN[0]
    if len(VALEUR) > 18: VALEUR = VALEUR[:16] + ".."
    VALEUR = " " + VALEUR + (" " * (18 - len(VALEUR))) + " "
    LIGNE = LIGNE +  VALEUR + a01
    # 02 - TYPE LAYER
    VALEUR = LN[1]
    if len(VALEUR) > 10: VALEUR = VALEUR[:8] + ".."
    VALEUR = " " + VALEUR + (" " * (10 - len(VALEUR))) + " "
    LIGNE = LIGNE + VALEUR + a01
    # 03 - SEL LAYER
    VALEUR = LN[2]
    if len(VALEUR) > 10: VALEUR = VALEUR[:8] + ".."
    VALEUR = " " + VALEUR + (" " * (10 - len(VALEUR))) + " "
    LIGNE = LIGNE + VALEUR + a01
    for j in range(3,11):
        VALEUR = str(LN[j])
        VALEUR = " " + VALEUR + (" " * (8- len(VALEUR))) + " "
        if j <10 : LIGNE = LIGNE + VALEUR + a01
        if j == 10:  LIGNE = LIGNE + VALEUR + a08
    return LIGNE

# ---------------------------------------
# Fichier texte de parametre de la NEIGe
# -- Lecture du fichier de parametres - NOM|TYPE|SOURCE
# NOM = nom du calque
# TYPE = pritive graphique - POINT|POLYLIGNE|POLYGONE
# SOURCE = source par defaut - AERIEN|TERRESTRE|MIXTE
Tableau_NEIGe = []
file = open("C:\Temp\PYTHON SERAIL\NEIGE_2012.txt", "r")
for line in file:
    arcpy.AddMessage(line.rstrip())
    L = line.rstrip().split('|')
    Tableau_NEIGe.append([L[0],L[1],L[2],0,0,0,0,0,0,0,0])
file.close()
Tableau_NEIGe.sort()
#---------------------------------------
PT_Z = True
PL_Z = True
PG_Z = True
PT_NB = 0
PL_NB = 0
PG_NB = 0
#Nom du fichier CAD a tester
#Nom_fichier_CAD_a_controler = r'C:\Temp\DUMBEA_ajout.dxf'
Nom_fichier_CAD_a_controler = arcpy.GetParameterAsText(0).encode('utf-8')
#arcpy.AddMessage(str(os.path.dirname(Nom_fichier_CAD_a_controler)))
Nom_fichier_resultat = (Nom_fichier_CAD_a_controler[:-4] +"_VERIF_NEIGe.txt").decode('utf-8').encode('cp1252')
if os.path.isfile(Nom_fichier_resultat): os.remove(Nom_fichier_resultat)
file = open(Nom_fichier_resultat, "a")
file.write("Date : " + datetime.datetime.today().strftime('%d-%m-%Y') + "\n")
file.write("Fichier : " + Nom_fichier_CAD_a_controler + "\n")
file.write("Utilisateur : " + os.getenv("USERNAME") + "\n")
file.write("-----------------------------------------------" + "\n\n")
#arcpy.AddMessage(Nom_fichier_resultat)
#---------------------------------------
Set_layer_non_NEIGe = set()
layer_point = Nom_fichier_CAD_a_controler + '\Point'
desc = arcpy.Describe(layer_point)
LISTE_CHM = []
if not desc.HasZ :
    arcpy.AddMessage(" ! LA COUCHE DES POINTS EST EN 2D")
    LISTE_CHM = ['Layer','RefName','Entity','SHAPE@']
    PT_Z = False
else :
    LISTE_CHM = ['Layer', 'RefName', 'Entity', 'SHAPE@','SHAPE@Z']
Nombre_objet_div_10 = int(int(arcpy.GetCount_management(layer_point).getOutput(0)) / 10)
compteur = 0
cmp = 0
pourcentage_avance = 0
with arcpy.da.SearchCursor(layer_point, LISTE_CHM) as cursor:
     arcpy.AddMessage("ANALYSE POINT --> {}".format(pourcentage_avance))
     for row in cursor:
        compteur = compteur + 1
        cmp = cmp +1
        if compteur == Nombre_objet_div_10:
            compteur = 0
            pourcentage_avance = pourcentage_avance + 10
            arcpy.AddMessage("ANALYSE POINT --> {}".format(pourcentage_avance))
        Result_layer = ""
        for LN in Tableau_NEIGe:
           if row[0] == LN[0] :
               Result_layer =  LN[0]
               if row[3] != None:
                    # Un objet ponctuel supplementaire
                    if row[2] == "Point": LN[3] = LN[3]+1
                    # Nombre de blocs
                    if row[2] == "Insert": LN[4] = LN[4]+1
                    # Nom du bloc  = au nom du layer ?
                    if row[1] == LN[0]:  LN[5] = LN[5]+1
                    if desc.HasZ:
                        # Z = 0 ?
                        if row[4] == 0: LN[8] = LN[8] + 1
                        if row[4] == 0: LN[9] = LN[9] + 1
                    else :
                        LN[8] = -1
                        LN[9] = -1
               else:
                    LN[10] = LN[10]+1
               break
        # ------ traitement du resultat
        if Result_layer == "":
            # layer non NEIGe
            Set_layer_non_NEIGe.add(row[0])
PT_NB = cmp
#-------------------------------------------------------------------------------------------------------
layer_polyline = Nom_fichier_CAD_a_controler + '\Polyline'
Nombre_objet_div_10 = int(int(arcpy.GetCount_management(layer_polyline).getOutput(0)) / 10)
compteur = 0
cmp = 0
pourcentage_avance = 0
desc = arcpy.Describe(layer_polyline)
if not desc.HasZ :
     arcpy.AddMessage(" ! LA COUCHE DES POLYLIGNES EST EN 2D")
     PL_Z = False
with arcpy.da.SearchCursor(layer_polyline, ['Layer','RefName','SHAPE@']) as cursor:
     arcpy.AddMessage("ANALYSE POLYLIGNE --> {}".format(pourcentage_avance))
     for row in cursor:
        compteur = compteur + 1
        cmp = cmp +1
        if compteur == Nombre_objet_div_10:
            compteur = 0
            pourcentage_avance = pourcentage_avance + 10
            arcpy.AddMessage("ANALYSE POLYLIGNE --> {}".format(pourcentage_avance))
        Result_layer = ""
        for LN in Tableau_NEIGe:
           if row[0] == LN[0] :
               Result_layer =  LN[0]
               # Un objet polyline supplementaire
               LN[6] = LN[6]+1
               if LN[1] == "POLYGONE" or LN[1] == "POLYLIGNE":
                    if desc.HasZ:
                        # Z = 0 ?
                        ONE_0 = False
                        ALL_0 = True
                        if row[2] != None:
                            for part in row[2]:
                                for pnt in part:
                                    if pnt:
                                        if pnt.Z == 0:
                                            ONE_0 = True
                                        else:
                                            ALL_0 = False
                            if ONE_0 == True: LN[8] = LN[8] + 1
                            if ALL_0 == True: LN[9] = LN[9] + 1
                        else:
                            LN[10] = LN[10] + 1
                    else:
                        LN[8] = -1
                        LN[9] = -1
               break
        # ------ traitement du resultat
        if Result_layer == "":
            # layer non NEIGe
            Set_layer_non_NEIGe.add(row[0])
PL_NB = cmp
#-------------------------------------------------------------------------------------------------------
layer_polygon = Nom_fichier_CAD_a_controler + '\Polygon'
Nombre_objet_div_10 = int(int(arcpy.GetCount_management(layer_polygon).getOutput(0)) / 10)
compteur = 0
cmp = 0
pourcentage_avance = 0
desc = arcpy.Describe(layer_polygon)
if not desc.HasZ :
     arcpy.AddMessage(" ! LA COUCHE DES POLYGONES EST EN 2D")
     PG_Z = False
with arcpy.da.SearchCursor(layer_polygon, ['Layer','RefName','SHAPE@','OID@']) as cursor:
     arcpy.AddMessage("ANALYSE POLYGONE --> {}".format(pourcentage_avance))
     for row in cursor:
        cmp = cmp +1
        compteur = compteur + 1
        if compteur == Nombre_objet_div_10:
            compteur = 0
            pourcentage_avance = pourcentage_avance + 10
            arcpy.AddMessage("ANALYSE POLYGONE --> {}".format(pourcentage_avance))
        Result_layer = ""
        for LN in Tableau_NEIGe:
           if row[0] == LN[0] :
               Result_layer =  LN[0]
               # Un objet polygone supplementaire
               LN[7] = LN[7]+1
               break
        # ------ traitement du resultat
        if Result_layer == "":
            # layer non NEIGe
            Set_layer_non_NEIGe.add(row[0])
PG_NB = cmp
# ---------------------------------------------
file.write("NB OBJETS ANALYSES ET ASSIMILES A DES POINTS : " + str(PT_NB)+ "\n")
file.write("NB OBJETS ANALYSES ET ASSIMILES A DES POLYLIGNES : " + str(PL_NB)+ "\n")
file.write("NB OBJETS ANALYSES ET ASSIMILES A DES POLYLGONES : " + str(PG_NB)+ "\n")
file.write("\n")
# ---
if not(PT_Z) or not(PL_Z) or not(PG_Z) :
    if not(PT_Z) : file.write("--> COUCHE POINT EN 2D"+ "\n")
    if not(PL_Z) : file.write("--> COUCHE POLYLIGNE EN 2D"+ "\n")
    if not(PG_Z) : file.write("--> COUCHE POLYGONE EN 2D"+ "\n")
    file.write("\n")
# ---
arcpy.AddMessage("----------- CALQUES NON NEIGE -------------------------")
file.write("------------------------------------- CALQUES NON NEIGE -------------------------------------" + "\n")
Liste_layer_non_NEIGe = list(Set_layer_non_NEIGe)
for f in Liste_layer_non_NEIGe:
    arcpy.AddMessage("  - " + f)
    file.write("  - " + f + "\n")
#file.write("-------------------------------------" + "\n\n")
# ---------------------------------------------
arcpy.AddMessage("----------- CALQUES NEIGE NON VALIDES")
file.write("------------------------------------- CALQUES NEIGE NON VALIDES -------------------------------------" + "\n")
for LN in Tableau_NEIGe:
     if LN[3]>0 or LN[4]>0 or LN[6]>0 or LN[7]>0 :
        valid = True
        message = ""
        if LN[10] > 0 :
            valid = False
            message = message + "    --> Ce calque contient un ou des objets dont la geometrie n'a pu etre analysee."
        if LN[1] == "POINT" and (LN[4] > 0 or LN[6] > 0 or LN[7] > 0) :
            valid = False
            message = message + "    --> Ce calque ne doit comporter que des objets de type POINT. Il contient des blocs ou des polylignes."
        if LN[1] == "POLYGONE" and (LN[6] != LN[7]):
            valid = False
            message = message + "    --> Ce calque ne doit comporter que des objets de type POLYGONE (= polylignes fermees). Il contient des lignes qui ne sont pas fermees."
        if (LN[1] == "POLYLIGNE") and (LN[3] > 0 or LN[4] > 0):
            valid = False
            message = message + "    --> Ce calque ne doit comporter que des objets de type POLYLIGNE. Il contient des points ou des blocs."
        if (LN[1] == "POLYGONE") and (LN[3] > 0 or LN[4] > 0):
            valid = False
            message = message + "    --> Ce calque ne doit comporter que des objets de type POLYGONE (= polylignes fermees). Il contient des points ou des blocs."
        if LN[1] == "BLOC" and (LN[6]>LN[4] or LN[7]>LN[4] or LN[3]>0) :
            valid = False
            message = message + "    --> Ce calque ne doit comporter que des blocs. Il contient des lignes ou des polygones."
        if LN[1] == "BLOC" and LN[4]>LN[5]:
            valid = False
            message = message + "    --> Ce calque ne doit comporter que des blocs dont le nom est le meme que celui du calque. Il contient des blocs avec un nom different que celui du calque."
        if valid == False:
            M1 = ("  - " + LN[0] + " TYPE:" + LN[1] + " SEL:" + LN[2] + " PT:" + str(LN[3]) + " BLOC:" + str(LN[4])  + " BLOC=NOM:" + str(LN[5]) + " PL:" + str(LN[6]) + " PG:" + str(LN[7]) + " Z=0:" + str(LN[8]) + " ALL_Z=0:" + str(LN[9]) + " PROB_GEOM:" + str(LN[10]))
            arcpy.AddMessage(M1)
            file.write(M1 + "\n")
            arcpy.AddMessage(message)
            file.write(message + "\n")
            file.write("" + "\n")
file.write("\n")

arcpy.AddMessage("")
file.write(LIGNE_DEP() + "\n")
file.write(LIGNE_VIERGE() + "\n")
file.write(INTERLIGNE() + "\n")
premier = False
for LN in Tableau_NEIGe:
    if LN[3] > 0 or LN[4] > 0 or LN[6] > 0 or LN[7] > 0:
        if premier: file.write(INTERLIGNE_SIMPLE() + "\n")
        file.write(LIGNE_RMPL(LN) + "\n")
        premier = True
file.write(LIGNE_FIN() + "\n\n")

file.write("------------------------------------- TERMINE" + "\n")
file.close()
arcpy.AddMessage("TERMINE")

